package cz.mendelu.dnaAnalyser.utils.analyse.service.heatmap;

import lombok.Data;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@Data
public class Heatmap {

    private List<Segment> data;

    private MetaData metaData;

    public Heatmap(int segmentCount, int segmentSize) {
        this.metaData = new MetaData(segmentCount, segmentSize);
        this.data = new ArrayList<>(segmentCount);
        for (int i = 0; i < segmentCount; i++) {
            this.data.add(new Segment());
        }
    }

    public List<Integer> counts() {
        return data.stream()
                .map(s -> (int)s.getCount())
                .collect(Collectors.toList());
    }

    public List<Double> coverages() {
        return data.stream()
                .map(Segment::getCoverage)
                .collect(Collectors.toList());
    }
}
