package cz.mendelu.dnaAnalyser.utils.controller;

import lombok.Data;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;


/**
 * Created by Honza on 22.08.2016.
 */
@Data
public class PaginationParam {

    public static final String PAGE_SIZE_ALL = "ALL";

    private String pageSize = "20";

    private Integer pageNumber = 0;

    public Pageable toPageable(Sort sort) {
        int number = pageNumber;
        int size = this.getPageSize();
        if (sort == null) {
            sort = Sort.unsorted();
        }
        return PageRequest.of(number, size, sort);
    }

    public boolean isRequestForAll() {
        return PAGE_SIZE_ALL.equalsIgnoreCase(pageSize.trim());
    }

    public int getPageSize() {
        return (isRequestForAll())
                ? Integer.MAX_VALUE
                : Integer.parseInt(pageSize);
    }
}
